import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { getTabstopsRecord, replaceBody, replaceCustomVar, replaceTabstops } from "./replace";
import { mergeSnippet } from "./utils";
export * from "./types";
export default function defineSnippet(config, snippets) {
  var bodyRecord = mergeSnippet(snippets);
  var newSnippet = Object.entries(config).reduce(function (newSnippet, _ref) {
    var _snippetItem$extra;

    var _ref2 = _slicedToArray(_ref, 2),
        snippetName = _ref2[0],
        snippetItem = _ref2[1];

    var tabstopsRecord;

    if ((_snippetItem$extra = snippetItem.extra) !== null && _snippetItem$extra !== void 0 && _snippetItem$extra.tabstops) {
      var _snippetItem$extra2;

      tabstopsRecord = getTabstopsRecord((_snippetItem$extra2 = snippetItem.extra) === null || _snippetItem$extra2 === void 0 ? void 0 : _snippetItem$extra2.tabstops);
    }

    var newBodyRecord = Object.entries(bodyRecord).reduce(function (bodyRecord, _ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          snippetName = _ref4[0],
          body = _ref4[1];

      bodyRecord[snippetName] = body.map(function (code) {
        return replaceTabstops(code, snippetName, {
          tabstopsRecord: tabstopsRecord
        });
      });
      return bodyRecord;
    }, {});
    var body = snippetItem.body.map(function (code) {
      return replaceBody(code, {
        bodyRecord: newBodyRecord
      });
    });
    body = body.map(function (code) {
      var _snippetItem$extra3;

      return replaceCustomVar(code, {
        customVarRecord: (_snippetItem$extra3 = snippetItem.extra) === null || _snippetItem$extra3 === void 0 ? void 0 : _snippetItem$extra3.customVar
      });
    });
    var newSnippetItem = {
      prefix: snippetItem.prefix,
      scope: snippetItem.scope,
      description: snippetItem.description,
      body: body
    };
    newSnippet[snippetName] = newSnippetItem;
    return newSnippet;
  }, {});
  return newSnippet;
}